// Copyright 2000 Macromedia, Inc. All rights reserved.


//*-------------------------------------------------------------------
// CLASS:
//   RecordsetColumnMenu
//
// DESCRIPTION:
//
// PUBLIC PROPERTIES:
//
// PUBLIC FUNCTIONS:
//
//--------------------------------------------------------------------




//*-------------------------------------------------------------------
// FUNCTION:
//  RecordsetColumnMenu
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu(behaviorName, paramName, empty, rsParamName) {
  this.behaviorName = behaviorName;
  this.paramName = paramName;
  this.rsParamName = rsParamName;
  
  this.recordset = '';
  this.rsName = '';
  
  this.listControl = '';
}

//public methods
RecordsetColumnMenu.prototype.initializeUI = RecordsetColumnMenu_initializeUI;
RecordsetColumnMenu.prototype.updateUI = RecordsetColumnMenu_updateUI;
RecordsetColumnMenu.prototype.findServerBehaviors = RecordsetColumnMenu_findServerBehaviors;
RecordsetColumnMenu.prototype.canApplyServerBehavior = RecordsetColumnMenu_canApplyServerBehavior;
RecordsetColumnMenu.prototype.applyServerBehavior = RecordsetColumnMenu_applyServerBehavior;
RecordsetColumnMenu.prototype.inspectServerBehavior = RecordsetColumnMenu_inspectServerBehavior;
RecordsetColumnMenu.prototype.deleteServerBehavior = RecordsetColumnMenu_deleteServerBehavior;
RecordsetColumnMenu.prototype.analyzeServerBehavior = RecordsetColumnMenu_analyzeServerBehavior;
RecordsetColumnMenu.prototype.getValue = RecordsetColumnMenu_getValue;

//private methods
RecordsetColumnMenu.prototype.findAllColumnNames = RecordsetColumnMenu_findAllColumnNames;
RecordsetColumnMenu.prototype.colNameIsValid = RecordsetColumnMenu_colNameIsValid;



//*-------------------------------------------------------------------
// FUNCTION:
//   initializeUI()
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_initializeUI() {
  this.recordset = window[this.rsParamName];
  if (this.recordset.listControl.object.onChange) {
    this.recordset.listControl.object.onChange = this.paramName + ".updateUI();" +
                                                 this.recordset.listControl.object.onChange;
  } else {
    this.recordset.listControl.object.onChange = this.paramName + ".updateUI();";
  }
  
  this.listControl = new ListControl(this.paramName);
  
  this.updateUI();
}


//*-------------------------------------------------------------------
// FUNCTION:
//   updateUI()
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_updateUI() {
  this.rsName = this.recordset.listControl.get();
  var colNames = this.findAllColumnNames(this.rsName);
  this.listControl.setAll(colNames,colNames);
}


//*-------------------------------------------------------------------
// FUNCTION:
//   findServerBehaviors
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_findServerBehaviors(paramObj) {
  // no op
}



//*-------------------------------------------------------------------
// FUNCTION:
//   canApplyServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_canApplyServerBehavior(sbObj) {
  var retVal = true;
  return retVal;
}



//*-------------------------------------------------------------------
// FUNCTION:
//   applyServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_applyServerBehavior(sbObj, paramObj) {
  var retVal = "";
  var colName  = this.listControl.getValue();
  if (!colName || colName.indexOf("MM_ERROR") != -1) {
    retVal = MM.MSG_NeedColumn;
  }
  paramObj[this.paramName] = colName;
  return retVal;
}



//*-------------------------------------------------------------------
// FUNCTION:
//   inspectServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_inspectServerBehavior(sbObj) {
  this.updateUI();
  var colName = sbObj.parameters[this.paramName];
  var retVal = this.listControl.pickValue(colName);
  if (!retVal) {
    alert(errMsg(MM.MSG_CouldNotFindColumnName,colName));
  }
  return retVal;
}



//*-------------------------------------------------------------------
// FUNCTION:
//   deleteServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_deleteServerBehavior(sbObj) {
  // no op
}



//*-------------------------------------------------------------------
// FUNCTION:
//   analyzeServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_analyzeServerBehavior(sbObj, allRecs) {
  if (!sbObj.incomplete && !this.colNameIsValid(sbObj.parameters[this.rsParamName], sbObj.parameters[this.paramName])) {
    sbObj.incomplete = true;
  }
}


//*-------------------------------------------------------------------
// FUNCTION:
//   getValue
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_getValue() {
  return this.listControl.getValue();
}


//*-------------------------------------------------------------------
// FUNCTION:
//   findAllColumnNames
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_findAllColumnNames(rsName) {
  var retVal = false;
  retVal = findAllColumnNames(rsName);
  return retVal;
}


//*-------------------------------------------------------------------
// FUNCTION:
//   colNameIsValid
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetColumnMenu_colNameIsValid(rsName, colName) {
  var retVal = false;
  
  if (colName) {
    var colNames = this.findAllColumnNames(rsName);
    for (var i=0; i < colNames.length; i++) {
      if (colNames[i] == colName) {
        retVal = true;
        break;
      }
    }
  }
  
  return retVal;
}



