// Copyright 2000 Macromedia, Inc. All rights reserved.


//*-------------------------------------------------------------------
// CLASS:
//   RecordsetFieldMenu
//
// DESCRIPTION:
//
// PUBLIC PROPERTIES:
//
// PUBLIC FUNCTIONS:
//
//--------------------------------------------------------------------




//*-------------------------------------------------------------------
// FUNCTION:
//  RecordsetFieldMenu
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu(behaviorName, paramName, empty, rsParamName) {
  this.behaviorName = behaviorName;
  this.paramName = paramName;
  this.rsParamName = rsParamName;
  
  this.recordset = '';
  this.rsName = '';
  
  this.listControl = '';
}

//public methods
RecordsetFieldMenu.prototype.initializeUI = RecordsetFieldMenu_initializeUI;
RecordsetFieldMenu.prototype.updateUI = RecordsetFieldMenu_updateUI;
RecordsetFieldMenu.prototype.findServerBehaviors = RecordsetFieldMenu_findServerBehaviors;
RecordsetFieldMenu.prototype.canApplyServerBehavior = RecordsetFieldMenu_canApplyServerBehavior;
RecordsetFieldMenu.prototype.applyServerBehavior = RecordsetFieldMenu_applyServerBehavior;
RecordsetFieldMenu.prototype.inspectServerBehavior = RecordsetFieldMenu_inspectServerBehavior;
RecordsetFieldMenu.prototype.deleteServerBehavior = RecordsetFieldMenu_deleteServerBehavior;
RecordsetFieldMenu.prototype.analyzeServerBehavior = RecordsetFieldMenu_analyzeServerBehavior;
RecordsetFieldMenu.prototype.getValue = RecordsetFieldMenu_getValue;

//private methods
RecordsetFieldMenu.prototype.findAllFieldNames = RecordsetFieldMenu_findAllFieldNames;
RecordsetFieldMenu.prototype.fieldNameIsValid = RecordsetFieldMenu_fieldNameIsValid;



//*-------------------------------------------------------------------
// FUNCTION:
//   initializeUI()
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_initializeUI() {
  if (this.rsParamName) {
    this.recordset = window[this.rsParamName];
  } else {
    for (var i in window) {
      if (typeof window[i] == "object" &&
          window[i].isRecordsetMenu) {
        this.recordset = window[i];
        this.rsParamName = this.recordset.paramName;
        break;
      }
    }
  }
  
  if (this.recordset) {
    if (this.recordset.listControl.object.onChange) {
      this.recordset.listControl.object.onChange = "_" + this.paramName + ".updateUI();" +
                                                   this.recordset.listControl.object.onChange;
    } else {
      this.recordset.listControl.object.onChange = "_" + this.paramName + ".updateUI();";
    }
  }
  
  this.listControl = new ListControl(this.paramName);
  
  this.updateUI();
}


//*-------------------------------------------------------------------
// FUNCTION:
//   updateUI()
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_updateUI() {
  if (this.recordset) {
    this.rsName = this.recordset.listControl.get();
    var colNames = this.findAllFieldNames(this.rsName);
    this.listControl.setAll(colNames,colNames);
  }
}


//*-------------------------------------------------------------------
// FUNCTION:
//   findServerBehaviors
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_findServerBehaviors(paramObj) {
  // no op
}



//*-------------------------------------------------------------------
// FUNCTION:
//   canApplyServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_canApplyServerBehavior(sbObj) {
  var retVal = true;
  return retVal;
}



//*-------------------------------------------------------------------
// FUNCTION:
//   applyServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_applyServerBehavior(sbObj, paramObj) {
  var retVal = "";
  var colName  = this.listControl.getValue();
  if (!colName || colName.indexOf("MM_ERROR") != -1) {
    retVal = MM.MSG_NeedColumn;
  }
  paramObj[this.paramName] = colName;
  return retVal;
}



//*-------------------------------------------------------------------
// FUNCTION:
//   inspectServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_inspectServerBehavior(sbObj) {
  var retVal = false;
  if (this.recordset) {
    this.updateUI();
    var colName = sbObj.parameters[this.paramName];
    retVal = this.listControl.pickValue(colName);
    if (!retVal) {
      alert(errMsg(MM.MSG_CouldNotFindFieldName,colName));
    }
  }
  return retVal;
}



//*-------------------------------------------------------------------
// FUNCTION:
//   deleteServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_deleteServerBehavior(sbObj) {
  // no op
}



//*-------------------------------------------------------------------
// FUNCTION:
//   analyzeServerBehavior
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_analyzeServerBehavior(sbObj, allRecs) {
  if (this.rsParamName &&
      !sbObj.incomplete && 
      !this.fieldNameIsValid(sbObj.parameters[this.rsParamName], sbObj.parameters[this.paramName])) {
    sbObj.incomplete = true;
  }
}


//*-------------------------------------------------------------------
// FUNCTION:
//   getValue
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_getValue() {
  return this.listControl.getValue();
}



//*-------------------------------------------------------------------
// FUNCTION:
//   findAllFieldNames
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_findAllFieldNames(rsName) {
  var retVal = false;
  
  var serverModel = dw.getDocumentDOM().serverModel.getServerName();
  
  //ask dreamweaver for the list of data sources
  var dsList = dw.dbi.getDataSources();
  
  //find the data source with the given name
  for (var i=0; i < dsList.length; i++) {
    if (dsList[i].name == rsName || dsList[i].title == rsName) {
      var dataSource = dsList[i].dataSource;
            
      //get the dom of the data source
      var dsDOM = dreamweaver.getDocumentDOM(dreamweaver.getConfigurationPath() + "/DataSources/" + serverModel + "/" + dataSource);

      //call the generateDynamicSourceBindings function
      if (dsDOM) {
        objList = dsDOM.parentWindow.generateDynamicSourceBindings(rsName);
        if (objList && objList.length) {
          retVal = new Array();
          for (var j=0; j < objList.length; j++) {
            retVal.push(objList[j].title);
          }
        }
      }
      
      break;
    }
  }
  
  return retVal;
}


//*-------------------------------------------------------------------
// FUNCTION:
//   fieldNameIsValid
//
// DESCRIPTION:
//
// ARGUMENTS: 
//
// RETURNS:
//--------------------------------------------------------------------
function RecordsetFieldMenu_fieldNameIsValid(rsName, fieldName) {
  var retVal = false;
  
  if (fieldName) {
    var fieldNames = this.findAllFieldNames(rsName);
    for (var i=0; fieldNames && i < fieldNames.length; i++) {
      if (fieldNames[i] == fieldName) {
        retVal = true;
        break;
      }
    }
  }
  
  return retVal;
}



